// MTIDE.H
/**************************************************************************/
/**                                                                      **/
/**                  LIBRAIRIE DE CALCUL DES MAREES (header)             **/
/**                                                                      **/
/**************************************************************************/

#define STRICT

#include "precisio.h"

// Fichier include generaux
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
// #include <complex.h>
#include <complex>
#define M_PI 3.1415926535897932384626433832795028841971693993751
#define M_PI_2 (M_PI / 2)

#include <malloc.h>
#include <io.h>
#include <time.h>
#include "fourier.h"

using namespace std;

#define NUMCONST 100			// Nombre de constantes maximum
#define PRECISION 3600			// Precision dutableau : une heure

extern MINT NUMJOURS;			// Nombre de jours de l'etude
extern LLONG NUMPOINTS;			// Nombre de points tableau.

extern BOOL Ver_FFT;			// Temporaire

#define FALSE 0
#define BOOL int

extern MINT *tab;
extern LDOUBLE dop;
extern BOOL CFourier;

struct tonde			// Structure d'une onde
 {
  LDOUBLE speed;
  LDOUBLE ampl;
  LDOUBLE etab;
  CHAR name[100];
 };

extern LDOUBLE Z0;		        // Niveau moyen
extern MINT NumOnde;			// Nombre d'ondes correctes
extern MINT NumOndeBis;			// Numero de l'onde a traiter

extern struct tonde ondes [NUMCONST];  // Tableau des Constantes


LDOUBLE tide (LDOUBLE t,MINT onde=0);
LDOUBLE dtide (LDOUBLE t, MINT onde = 0);
LDOUBLE ddtide (LDOUBLE t, MINT onde = 0);
LDOUBLE newton (LDOUBLE fonction (LDOUBLE),LDOUBLE premiere (LDOUBLE),LDOUBLE seconde (LDOUBLE),LDOUBLE point,LDOUBLE precision=0.01);
LDOUBLE get_tide (LDOUBLE t);		// t : Temps en secondes
LDOUBLE get_dtide (LDOUBLE t);		// t : Temps en secondes
LDOUBLE get_ddtide (LDOUBLE t);		// t : Temps en secondes
LDOUBLE rget_tide (LLONG t);		// t : Temps en secondes
LDOUBLE rget_dtide (LLONG t);		// t : Temps en secondes
LDOUBLE rget_ddtide (LLONG t);		// t : Temps en secondes
LDOUBLE det_onde_fonction (LDOUBLE x);
LDOUBLE det_onde_premiere (LDOUBLE x);
LDOUBLE det_onde_seconde (LDOUBLE x);
struct tonde det_onde_periode_fourier (LDOUBLE p);
struct tonde det_onde_periode (LDOUBLE p);
struct tonde det_precis_func (DOUBLE p, DOUBLE pas, DOUBLE prec);
struct tonde det_max_periode (void);













